"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/helptips/index.ts
var helptips_exports = {};
__export(helptips_exports, {
  BaseOnboardingTip: () => BaseOnboardingTip,
  BaseOnboardingTooltip: () => BaseOnboardingTooltip,
  CompletionButton: () => CompletionButton,
  DashboardOnboardingPendings: () => DashboardOnboardingPendings,
  DashboardOnboardingState: () => DashboardOnboardingState,
  DeploymentUploadFinished: () => DeploymentUploadFinished,
  DeploymentsInprogress: () => DeploymentsInprogress,
  DeploymentsPast: () => DeploymentsPast,
  DeploymentsPastCompletedFailure: () => DeploymentsPastCompletedFailure,
  DevicePendingTip: () => DevicePendingTip,
  DevicesAcceptedOnboarding: () => DevicesAcceptedOnboarding,
  DevicesDeployReleaseOnboarding: () => DevicesDeployReleaseOnboarding,
  DevicesPendingAcceptingOnboarding: () => DevicesPendingAcceptingOnboarding,
  DevicesPendingDelayed: () => DevicesPendingDelayed,
  GetStartedTip: () => GetStartedTip,
  HELPTOOLTIPS: () => HELPTOOLTIPS,
  MenderHelpTooltip: () => MenderHelpTooltip,
  OnboardingCompleteTip: () => OnboardingCompleteTip,
  SchedulingAllDevicesSelection: () => SchedulingAllDevicesSelection,
  SchedulingArtifactSelection: () => SchedulingArtifactSelection,
  SchedulingGroupSelection: () => SchedulingGroupSelection,
  SchedulingReleaseToDevices: () => SchedulingReleaseToDevices,
  orientations: () => orientations
});
module.exports = __toCommonJS(helptips_exports);

// src/helptips/BaseOnoardingTip.tsx
var import_react = __toESM(require("react"), 1);
var import_react_redux = require("react-redux");
var import_icons_material = require("@mui/icons-material");
var import_material = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_common_ui = require("@northern.tech/common-ui");
var import_actions = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants = require("@northern.tech/store/constants");
var import_helpers = require("@northern.tech/utils/helpers");
var import_tracking = __toESM(require("@northern.tech/utils/tracking"), 1);
var import_jsx_runtime = require("react/jsx-runtime");
var { setShowDismissOnboardingTipsDialog } = import_actions.default;
var iconWidth = 30;
var orientations = {
  top: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowUpward, {}),
    placement: "bottom",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  right: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowBack, {}),
    placement: "right",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      style.left = style.left + iconWidth / 2;
      return style;
    }
  },
  bottom: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowDownward, {}),
    placement: "top",
    offsetStyle: (style) => {
      style.left = style.left - iconWidth / 2;
      return style;
    }
  },
  left: {
    arrow: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_icons_material.ArrowForward, {}),
    placement: "left",
    offsetStyle: (style) => {
      style.top = style.top - iconWidth / 2;
      return style;
    }
  }
};
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  root: {
    [`.${import_material.buttonBaseClasses.root}.${import_material.buttonClasses.text}`]: { color: theme.palette.background.paper, paddingRight: 0 }
  }
}));
var BaseOnboardingTooltip = ({ anchor = { left: 0, top: 0 }, icon, children, id = "1", place = "top", ...props }) => {
  const [open, setOpen] = (0, import_react.useState)(false);
  const showDismissHelptipsDialog = (0, import_react_redux.useSelector)((state) => state.onboarding.showTipsDialog);
  const showDeviceConnectionDialog = (0, import_react_redux.useSelector)((state) => state.users.showConnectDeviceDialog);
  const delayTimer = (0, import_react.useRef)();
  const { classes } = useStyles();
  (0, import_react.useEffect)(() => {
    import_tracking.default.event({ category: "onboarding", action: id });
    clearTimeout(delayTimer.current);
    delayTimer.current = setTimeout(() => setOpen(true), import_constants.TIMEOUTS.debounceShort);
    return () => {
      clearTimeout(delayTimer.current);
    };
  }, [id]);
  const toggleVisibility = () => setOpen(import_helpers.toggle);
  const hide = () => setOpen(false);
  if (showDismissHelptipsDialog || showDeviceConnectionDialog) {
    return null;
  }
  const orientation = orientations[place];
  const style = orientation.offsetStyle({ left: anchor.left, top: anchor.top, overflow: "initial" });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_common_ui.OnboardingTooltip,
    {
      disableFocusListener: true,
      disableHoverListener: true,
      disableTouchListener: true,
      id,
      onClose: hide,
      open,
      placement: orientation.placement,
      PopperProps: {
        className: classes.root,
        disablePortal: true,
        popperOptions: {
          strategy: "fixed",
          modifiers: [
            { name: "flip", enabled: false },
            { name: "preventOverflow", enabled: true, options: { boundary: window, altBoundary: false } }
          ]
        }
      },
      title: children,
      className: classes.root,
      ...props,
      children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: "onboard-tip", onClick: toggleVisibility, style, children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { className: `tooltip onboard-icon ${orientation.placement}`, children: icon ?? orientation.arrow }) })
    }
  );
};
var BaseOnboardingTip = ({ anchor, icon, component, place, id, ...others }) => {
  const dispatch = (0, import_react_redux.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(BaseOnboardingTooltip, { anchor, icon, place, id, children: /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("div", { className: "content", children: [
    import_react.default.cloneElement(component, others),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("b", { className: "clickable", onClick: () => dispatch(setShowDismissOnboardingTipsDialog(true)), children: "Dismiss the tutorial" }) })
  ] }) });
};
var BaseOnoardingTip_default = BaseOnboardingTip;

// src/helptips/HelpTooltips.tsx
var import_react2 = require("react");
var import_react_redux2 = require("react-redux");
var import_common_ui2 = require("@northern.tech/common-ui");
var import_actions2 = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants2 = require("@northern.tech/store/constants");
var import_selectors = require("@northern.tech/store/selectors");
var import_thunks = require("@northern.tech/store/thunks");
var import_jsx_runtime2 = require("react/jsx-runtime");
var { setSnackbar } = import_actions2.default;
var AuthExplainButton = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_common_ui2.LogDialog, {}),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Device authorization status" }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "Each device sends an authentication request containing its identity attributes and its current public key. You can accept, reject or dismiss these requests to determine the authorization status of the device." }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "In cases such as key rotation, each device may have more than one identity/key combination listed. See the documentation for more on",
    " ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_common_ui2.DocsLink, { path: "overview/device-authentication", title: "Device authentication" }),
    "."
  ] })
] });
var AuthButton = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Authorize devices" }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "Expand this section to view the authentication options for this device. You can decide whether to accept it, reject it, or just dismiss this device for now." }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "See the documentation for more on ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_common_ui2.DocsLink, { path: "overview/device-authentication", title: "Device authentication" }),
    "."
  ] })
] });
var AddGroup = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Device groups" }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "It is possible to create groups of devices. Once you have created a group and added one or more devices to it, you can deploy an update to that specific group only." })
] });
var ExpandArtifact = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Device type compatibility" }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "Mender Artifacts have ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { children: "Device types compatible" }),
    " as part of their metadata. All devices report which device type they are, as part of their inventory information. During a deployment, Mender makes sure that a device will only download and install an Artifact it is compatible with."
  ] }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "You can click on each Artifact in the Release to expand the row and view more information about it." }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "For more information on how to specify the device type compatibility and other artifact metadata,",
    " ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_common_ui2.DocsLink, { path: "artifact-creation/create-an-artifact", title: "see the documentation" }),
    "."
  ] })
] });
var DeviceSupportTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
  "The steps in the guide should work on most operating systems in the Debian family (e.g. Debian, Ubuntu, Raspberry Pi OS) and devices based on ARMv6 or newer (e.g. Raspberry Pi 2/3/4, Beaglebone). Visit ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_common_ui2.DocsLink, { path: "overview/device-support", title: "our documentation" }),
  " for more information about device support."
] });
var ConfigureTimezoneTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  "To see the effects of applying a configuration to your device you can set one of the below values to modify the timezone of your device. While all values from ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("i", { children: "timedatectl list-timezones" }),
  " will work, to easily see the impact of the changed value you can use one of the following values:",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("ul", { children: [
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("li", { children: "Europe/Oslo" }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("li", { children: "America/Los_Angeles" }),
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("li", { children: "Asia/Tokyo" })
  ] }),
  "Once the configuration has been applied you can see the effect by opening the Remote Terminal to the device and executing the ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("i", { children: "date" }),
  " command."
] });
var ConfigureRaspberryLedTip = () => {
  const dispatch = (0, import_react_redux2.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
    "To see the effects of applying a configuration to your device you can set one of the below values to modify the behaviour of your Raspberry Pi green status LED",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
      import_common_ui2.ConfigurationObject,
      {
        className: "margin-top-small margin-bottom-small",
        config: {
          mmc0: "The default, which blinks the led on storage activity",
          on: "Turn on the light permanently",
          off: "Turn off the light permanently",
          heartbeat: "Enable heartbeat blinking"
        },
        compact: true,
        setSnackbar: (...args) => dispatch(setSnackbar(...args))
      }
    ),
    "There are other possible values, but we won't advertise them here. See",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("a", { href: "http://www.d3noob.org/2020/07/controlling-activity-led-on-raspberry-pi.html", target: "_blank", rel: "noopener noreferrer", children: "this blog post" }),
    " ",
    "or",
    " ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("a", { href: "https://www.raspberrypi.org/forums/viewtopic.php?t=273194#p1658930", target: "_blank", rel: "noopener noreferrer", children: "in the Raspberry Pi forums" }),
    " ",
    "for more information."
  ] });
};
var ConfigureAddOnTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
  "Mender deploys the configuration attributes using the same mechanisms as software updates. The configuration is stored as a JSON file at",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("code", { children: "/var/lib/mender-configure/device-config.json" }),
  " on the device and then all the scripts in",
  " ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("code", { children: "/usr/lib/mender-configure/apply-device-config.d/" }),
  " are executed to apply the configuration attributes. To add a new configuration attribute, you simply need to input it in the UI and add a script to that directory that applies it accordingly."
] });
var NameTagTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  "The ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("i", { children: "Name" }),
  " tag will be available as a device indentifier too."
] });
var NameFilterTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Filtering by name is limited to devices with a previously defined name." });
var DeviceTypeTip = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "If you don't see your exact device on the list, choose ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("i", { children: "Generic ARMv6 or newer" }),
    " to continue the tutorial for now."
  ] }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)("p", { children: [
    "(Note: if your device is ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("i", { children: "not" }),
    " based on ARMv6 or newer, the tutorial won't work - instead, go back and use the virtual device)"
  ] })
] });
var TwoFactorNote = ({ className }) => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { className, children: "Two Factor Authentication is enabled for your account. If you haven't set up a 3rd party authentication app with a verification code, please contact an administrator." });
var AuditlogExplanation = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "The audit log shows the history of changes made to your Devices, Artifacts, Deployments, and user management." });
var DashboardWidget = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Add dashboard widgets to visualize the software distribution or geographical location of all your devices, or a group of your devices." });
var ScheduleDeployment = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "This time is relative to the server only \u2013 each device's time zone will not be taken into account. Devices across different time zones will receive the update at the same time." });
var GroupDeployment = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "The deployment will skip any devices in the group that are already on the target Release version, or that have an incompatible device type." });
var ForceDeployment = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Force update" }),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("p", { children: "This will make the Mender client install the update even if the selected release is already installed." })
] });
var ArtifactUpload = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Upload an Artifact to an existing or new Release" });
var PhasedPausedDeployments = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  "This feature is not available on ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { children: "phased deployments" }),
  ". If you'd like to set pause states between update steps, go back and adjust the rollout schedule to a ",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("b", { children: "single phase" }),
  "."
] });
var ResetHistory = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Greyed out items will not be considered during deployment roll out" });
var MenderArtifactUpload = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  "If there is no Release matching this Artifact\u2019s name, a new Release will be created for this Artifact.",
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("br", {}),
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("br", {}),
  "If there is already a Release matching this Artifact\u2019s name, the Artifact will be grouped in that Release."
] });
var SingleFileUpload = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "This will generate a single file application update Artifact, which requires some additional metadata to be entered." });
var GlobalSettings = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "These settings apply to all users, so changes made here may affect other users' experience." });
var Webhooks = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Use webhooks to send data about device lifecycle events to third-party systems. Currently you can only have one integration set up at a time." });
var WebhookEvents = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "You can select which type(s) of events the webhook will receive. Device authentication includes when devices are provisioned, decommissioned, or authentication status changes." });
var WebhookSecret = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "The secret is used for signing the requests sent to your webhook, to verify their authenticity. It is optional, but highly recommended for security. The secret must be a hexidecimal string (including only characters from A-F and 0-9)." });
var TenantToken = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("h3", { children: "Organization token" }),
  "This token is unique for your organization and ensures that only devices that you own are able to connect to your account."
] });
var SsoMetadata = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Submit the metadata document from your Identity Provider" });
var ReleaseName = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "If a Release with this name already exists, this new Artifact may be grouped into a Release with other Artifacts of the same name - so long as they are compatible with different device types" });
var TenantAdmin = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Set the user who will have the admin role when this tenant is created. This can be a user who already has a Mender account, or a brand new user. The tenant admin will be able to change which user(s) have this role once they begin using the tenant." });
var SubTenantDeviceLimit = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Set the maximum number of accepted devices this tenant can have connected to the server at any time. You can adjust this later. Each tenants\u2019 amount of accepted devices will count towards your total device limit." });
var SubTenantDeltaArtifactGeneration = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "This option will enable the server-side generation of Delta Artifacts for the created tenant when turned on" });
var SubTenantSSO = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "The created tenant will inherit the same Single Sign-On configuration as this Service Provider tenant. The created tenant\u2019s admin user will not be able to change the SSO settings later." });
var AttributeLimit = () => {
  const { isHosted } = (0, import_react_redux2.useSelector)(import_selectors.getFeatures);
  return isHosted ? /* @__PURE__ */ (0, import_jsx_runtime2.jsxs)(import_jsx_runtime2.Fragment, { children: [
    "Expand to see the list of attributes currently in use. Please",
    " ",
    /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("a", { href: "mailto:support@mender.io", target: "_blank", rel: "noopener noreferrer", children: "contact our team" }),
    " ",
    "if your use case requires a different set of attributes."
  ] }) : /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "Expand to see the list of attributes currently in use." });
};
var TenantInitialAdmin = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "The user that was assigned as admin for this tenant when it was created. There is a chance the admin user will have changed or this user no longer exists in this tenant." });
var PlanUpgradeEmail = () => /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_jsx_runtime2.Fragment, { children: "This email address will receive all payment receipts and notifications about pricing and device limits. It does not necessarily have to belong to a user in your Mender account" });
var HELPTOOLTIPS = {
  addGroup: { id: "addGroup", Component: AddGroup },
  artifactUpload: { id: "artifactUpload", Component: ArtifactUpload },
  attributeLimit: { id: "attributeLimit", Component: AttributeLimit },
  auditlogExplanation: { id: "auditlogExplanation", Component: AuditlogExplanation },
  authButton: { id: "authButton", Component: AuthButton },
  authExplainButton: { id: "authExplainButton", Component: AuthExplainButton },
  configureAddOnTip: { id: "configureAddOnTip", Component: ConfigureAddOnTip },
  configureRaspberryLedTip: {
    id: "configureRaspberryLedTip",
    Component: ConfigureRaspberryLedTip,
    isRelevant: ({ device = {} }) => {
      const { attributes = {} } = device;
      return ["raspberry", "rpi"].some((type) => attributes.device_type?.some((deviceType) => deviceType.startsWith(type)));
    }
  },
  configureTimezoneTip: {
    id: "configureTimezoneTip",
    Component: ConfigureTimezoneTip,
    isRelevant: ({ device = {} }) => {
      const { attributes = {} } = device;
      return ["raspberry", "rpi", "qemux86-64"].some((type) => attributes.device_type?.some((deviceType) => deviceType.startsWith(type)));
    }
  },
  dashboardWidget: { id: "dashboardWidget", Component: DashboardWidget },
  deviceSupportTip: { id: "deviceSupportTip", Component: DeviceSupportTip },
  deviceTypeTip: { id: "deviceTypeTip", Component: DeviceTypeTip },
  expandArtifact: { id: "expandArtifact", Component: ExpandArtifact },
  forceDeployment: { id: "forceDeployment", Component: ForceDeployment },
  globalSettings: { id: "globalSettings", Component: GlobalSettings },
  groupDeployment: { id: "groupDeployment", Component: GroupDeployment },
  menderArtifactUpload: { id: "menderArtifactUpload", Component: MenderArtifactUpload },
  nameFilterTip: { id: "nameFilterTip", Component: NameFilterTip },
  nameTagTip: { id: "nameTagTip", Component: NameTagTip },
  phasedPausedDeployments: { id: "phasedPausedDeployments", Component: PhasedPausedDeployments },
  planUpgradeEmail: { id: "planUpgradeEmail", Component: PlanUpgradeEmail },
  releaseName: { id: "releaseName", Component: ReleaseName },
  resetHistory: { id: "resetHistory", Component: ResetHistory },
  ssoMetadata: { id: "ssoMetadata", Component: SsoMetadata },
  scheduleDeployment: { id: "scheduleDeployment", Component: ScheduleDeployment },
  singleFileUpload: { id: "singleFileUpload", Component: SingleFileUpload },
  subTenantDeltaArtifactGeneration: { id: "subTenantDeltaArtifactGeneration", Component: SubTenantDeltaArtifactGeneration },
  subTenantDeviceLimit: { id: "subTenantDeviceLimit", Component: SubTenantDeviceLimit },
  subTenantSSO: { id: "subTenantSSO", Component: SubTenantSSO },
  tenantAdmin: { id: "tenantAdmin", Component: TenantAdmin },
  tenantInitialAdmin: { id: "tenantInitialAdmin", Component: TenantInitialAdmin },
  tenantToken: { id: "tenantToken", Component: TenantToken },
  twoFactorNote: { id: "twoFactorNote", SpecialComponent: TwoFactorNote },
  webhookEvents: { id: "webhookEvents", Component: WebhookEvents },
  webhooks: { id: "webhooks", Component: Webhooks },
  webhookSecret: { id: "webhookSecret", Component: WebhookSecret }
};
var MenderHelpTooltip = (props) => {
  const { id, contentProps = {} } = props;
  const tooltipsById = (0, import_react_redux2.useSelector)(import_selectors.getTooltipsState);
  const dispatch = (0, import_react_redux2.useDispatch)();
  const device = (0, import_react_redux2.useSelector)((state) => (0, import_selectors.getDeviceById)(state, contentProps.deviceId));
  const { readState = import_constants2.READ_STATES.unread } = tooltipsById[id] || {};
  const { Component, SpecialComponent, isRelevant = import_constants2.yes } = HELPTOOLTIPS[id];
  const onSetTooltipReadState = (0, import_react2.useCallback)((...args) => dispatch((0, import_thunks.setTooltipReadState)(...args)), [dispatch]);
  const onSetAllTooltipsReadState = (state) => dispatch((0, import_thunks.setAllTooltipsReadState)(state));
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    import_common_ui2.HelpTooltip,
    {
      setAllTooltipsReadState: onSetAllTooltipsReadState,
      setTooltipReadState: onSetTooltipReadState,
      device,
      tooltip: { Component, SpecialComponent, isRelevant, readState },
      ...props
    }
  );
};

// src/helptips/OnboardingCompleteTip.tsx
var import_react3 = require("react");
var import_react_redux3 = require("react-redux");
var import_icons_material2 = require("@mui/icons-material");
var import_material2 = require("@mui/material");
var import_mui2 = require("tss-react/mui");
var import_common_ui3 = require("@northern.tech/common-ui");
var import_constants3 = require("@northern.tech/store/constants");
var import_selectors2 = require("@northern.tech/store/selectors");
var import_thunks2 = require("@northern.tech/store/thunks");
var import_jsx_runtime3 = require("react/jsx-runtime");
var CompletionButton = (0, import_mui2.withStyles)(import_material2.Button, ({ palette }) => ({
  root: {
    backgroundColor: palette.background.default,
    "&:hover": {
      backgroundColor: palette.background.default
    }
  }
}));
var OnboardingCompleteTip = ({ anchor, targetUrl }) => {
  const timer = (0, import_react3.useRef)();
  const dispatch = (0, import_react_redux3.useDispatch)();
  const url = (0, import_react_redux3.useSelector)(import_selectors2.getDemoDeviceAddress) || targetUrl;
  (0, import_react3.useEffect)(() => {
    dispatch((0, import_thunks2.getDevicesByStatus)({ status: import_constants3.DEVICE_STATES.accepted })).unwrap().then((tasks) => Promise.all(tasks[tasks.length - 1].deviceAccu.ids.map((id) => dispatch((0, import_thunks2.getDeviceById)(id))))).finally(() => {
      timer.current = setTimeout(() => dispatch((0, import_thunks2.setOnboardingComplete)(true)), 12e4);
    });
    return () => {
      clearTimeout(timer.current);
    };
  }, [dispatch]);
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(
    import_common_ui3.MenderTooltipClickable,
    {
      className: "tooltip onboard-icon onboard-tip",
      id: import_constants3.onboardingSteps.DEPLOYMENTS_PAST_COMPLETED,
      onboarding: true,
      startOpen: true,
      style: anchor,
      PopperProps: { style: { marginLeft: -30, marginTop: -20 } },
      title: /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "content", children: [
        /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("b", { children: [
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("p", { children: "Fantastic! You completed your first deployment!" }),
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("p", { children: "Your deployment is finished and your device is now running the updated software." })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "margin-bottom-small margin-top-small", children: [
          !url ? /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_common_ui3.Loader, { show: true }) : /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(CompletionButton, { className: "button", variant: "text", href: `${url}/index.html?source=${encodeURIComponent(window.location)}`, target: "_blank", children: `Go to ${url}` }),
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("br", {}),
          "and you should see the demo web application actually being run on the device."
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("p", { children: "NOTE: if you have local network restrictions, you may need to check them if you have difficulty loading the page." }),
        /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)("div", { className: "flexbox", children: [
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { style: { flexGrow: 1 } }),
          /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_material2.Button, { variant: "contained", color: "secondary", onClick: () => dispatch((0, import_thunks2.setOnboardingComplete)(true)), children: "Close" })
        ] })
      ] }),
      children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_icons_material2.CheckCircle, {})
    }
  );
};

// src/helptips/OnboardingTips.tsx
var import_react_redux4 = require("react-redux");
var import_icons_material3 = require("@mui/icons-material");
var import_material3 = require("@mui/material");
var import_actions3 = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants4 = require("@northern.tech/store/constants");
var import_thunks3 = require("@northern.tech/store/thunks");
var import_jsx_runtime4 = require("react/jsx-runtime");
var { setShowConnectingDialog, setShowDismissOnboardingTipsDialog: setShowDismissOnboardingTipsDialog2 } = import_actions3.default;
var DevicePendingTip = (props) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(
  BaseOnoardingTip_default,
  {
    icon: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_icons_material3.Schedule, {}),
    component: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: 'If you followed the steps in "Connecting a device", your device will show here shortly.' }),
    ...props
  }
);
var GetStartedTip = (props) => {
  const dispatch = (0, import_react_redux4.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(BaseOnboardingTooltip, { ...props, children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "margin-top", style: { marginBottom: -12 }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("p", { children: /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("b", { children: "Welcome to Mender!" }) }),
    "We can help you get started with connecting your first device and deploying an update to it.",
    /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "flexbox center-aligned margin-top-small space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("b", { className: "clickable slightly-smaller", onClick: () => dispatch(setShowDismissOnboardingTipsDialog2(true)), children: "No thanks, I don't need help" }),
      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_material3.Button, { onClick: () => dispatch(setShowConnectingDialog(true)), children: "Get started" })
    ] })
  ] }) });
};
var DevicesPendingDelayed = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "If your device still isn't showing, try following the connection steps again or see our documentation for more." });
var DashboardOnboardingState = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Your device has requested to join the server. Click the row to expand the device details." });
var DevicesPendingAcceptingOnboarding = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { children: [
  "Your device has made a request to join the Mender server. You can inspect its identity details, such as mac address and public key, to verify it is definitely your device.",
  /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("br", {}),
  "When you are ready, Accept it!"
] });
var DashboardOnboardingPendings = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Next accept your device" });
var DevicesAcceptedOnboarding = (props) => {
  const dispatch = (0, import_react_redux4.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(BaseOnboardingTooltip, { ...props, children: /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "margin-top", style: { marginBottom: -12 }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { children: [
      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("p", { children: "Your device is now authenticated and has connected to the server! It's ready to receive updates, report its data and more." }),
      "Would you like to learn how to deploy your first update?"
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { className: "flexbox center-aligned margin-top-small space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("b", { className: "clickable slightly-smaller", onClick: () => dispatch(setShowDismissOnboardingTipsDialog2(true)), children: "Dismiss the tutorial" }),
      /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(import_material3.Button, { onClick: () => dispatch((0, import_thunks3.advanceOnboarding)(import_constants4.onboardingSteps.DEVICES_ACCEPTED_ONBOARDING)), children: "Yes, let's deploy!" })
    ] })
  ] }) });
};
var DevicesDeployReleaseOnboarding = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "From the Device actions, choose 'Create a deployment for this device'. You'll deploy an update to the device, using some demo software we have provided." });
var SchedulingArtifactSelection = ({ selectedRelease }) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: `Select the ${selectedRelease.name} release we included.` });
var SchedulingAllDevicesSelection = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsxs)("div", { children: [
  "Select 'All devices' for now.",
  /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("p", { children: "You can learn how to create device groups later." })
] });
var SchedulingGroupSelection = ({ createdGroup }) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: `Select the ${createdGroup} device group you just made.` });
var SchedulingReleaseToDevices = ({ selectedDevice, selectedGroup, selectedRelease }) => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: `Create the deployment! This will deploy the ${selectedRelease.name} Artifact to ${selectedDevice ? selectedDevice.id : selectedGroup || import_constants4.ALL_DEVICES}` });
var DeploymentsInprogress = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Your deployment is in progress. Click to view a report" });
var DeploymentUploadFinished = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Artifact upload is finished. Click to close the panel" });
var DeploymentsPast = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Your deployment has finished, click here to view it" });
var DeploymentsPastCompletedFailure = () => /* @__PURE__ */ (0, import_jsx_runtime4.jsx)("div", { children: "Your deployment has finished, but it looks like there was a problem. Click to view the deployment report, where you can see the error log." });
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BaseOnboardingTip,
  BaseOnboardingTooltip,
  CompletionButton,
  DashboardOnboardingPendings,
  DashboardOnboardingState,
  DeploymentUploadFinished,
  DeploymentsInprogress,
  DeploymentsPast,
  DeploymentsPastCompletedFailure,
  DevicePendingTip,
  DevicesAcceptedOnboarding,
  DevicesDeployReleaseOnboarding,
  DevicesPendingAcceptingOnboarding,
  DevicesPendingDelayed,
  GetStartedTip,
  HELPTOOLTIPS,
  MenderHelpTooltip,
  OnboardingCompleteTip,
  SchedulingAllDevicesSelection,
  SchedulingArtifactSelection,
  SchedulingGroupSelection,
  SchedulingReleaseToDevices,
  orientations
});
//# sourceMappingURL=index.cjs.map